#!/usr/bin/env python3
"""
Selects a random Grog of Substantial Whimsy effect.
Also does stuff from the Net Libram of Random Magic Effects.
"""
import os
import random

from module import commands

@commands("grog")
def grog(bot, trigger):
	"""
	Prints a status effect from Grog of Substantial Whimsy effect. If an
	index is not given, a random one is chosen.
	"""
	with open(os.path.join(bot.static, "grog.txt"), "r") as file:
		data = file.read().splitlines()
	num = None
	try:
		num = int(trigger.args[1]) - 1
	except (IndexError, ValueError):
		pass
	if num == None:
		num = random.randint(0, len(data)-1)
	if num >= len(data)-1:
		num = len(data)-1
	bot.msg(data[num])


@commands("magic")
def magic(bot, trigger):
	"""
	Prints a magic effect from the Net Libram of Random Magic Effects. If an
	index is not given, a random one is chosen.
	"""
	with open(os.path.join(bot.static, "netlibram.txt"), "r") as file:
		data = file.read().splitlines()
	num = None
	try:
		num = int(trigger.args[1]) - 1
	except (IndexError, ValueError):
		pass
	if num == None:
		num = random.randint(0, len(data)-1)
	if num >= len(data)-1:
		num = len(data)-1
	bot.msg(data[num])
